/*
Harpo by Alexander Abraham
licensed under the MIT license
*/
import 'dart:math';
/// This function gets the position of a letter
/// in the alphabet.
int encryptLetter(int factor, String letter){
  int result = 1;
  List<String> myList = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
  for(var i=0; i<myList.length; i++){
    if(myList[i] == letter){
      result = (myList.indexOf(letter) + 1) * factor;
      break;
    }
    else {
    }
  }
  return result;
}
/// This function gets the letter from a position
/// in the alphabet.
String decryptLetter(int factor, int encryptedLetter){
  List<String> myList = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
  String result = '';
  for(var i=0; i<myList.length; i++){
    int origIndex = (encryptedLetter/factor).round() - 1;
    if(i == origIndex){
      result = myList[i].toString();
      break;
    }
    else {
    }
  }
  return result;
}
/// This function takes a word and returns
/// a number sequence. These numbers are a
/// multiple of the corresponding letter's
/// position in the alphabet.
String encryptWord(int factor, String word){
  List<String> encryptedChars = [];
  List<String> charList = word.split('');
  for(var i=0; i<charList.length; i++){
    String result = encryptLetter(factor,charList[i]).toString();
    encryptedChars.add(result);
  }
  String newlyEncryptedString = encryptedChars.join('|');
  return newlyEncryptedString;
}
/// This function returns a word from a sequence of numbers
/// corresponding to the each letter's position in the alphabet.
String decryptWord(int factor, String encryptedWord){
  List<String> decryptedChars = [];
  List<String> charList = encryptedWord.split('|');
  for(var i=0; i<charList.length; i++){
    String result = decryptLetter(factor,int.parse(charList[i]));
    decryptedChars.add(result);
  }
  String newlyDecryptedString = decryptedChars.join('');
  return newlyDecryptedString;
}
/// This function does to phrases what their counterparts
/// do to words.
String encryptPhrase(int factor, String phrase){
  List<String> encryptedWords = [];
  List<String> wordList = phrase.split(' ');
  for(var i=0; i<wordList.length; i++){
    String result = encryptWord(factor,wordList[i]);
    encryptedWords.add(result);
  }
  String newlyEncryptedString = encryptedWords.join('=>');
  return newlyEncryptedString;
}
/// This function does to phrases what their counterparts
/// do to words.
String decryptPhrase(int factor, String encryptedPhrase){
  List<String> decryptedWords = [];
  List<String> wordList = encryptedPhrase.split('=>');
  for(var i=0; i<wordList.length; i++){
    String result = decryptWord(factor,wordList[i]);
    decryptedWords.add(result);
  }
  String newlyDecryptedString = decryptedWords.join(' ');
  return newlyDecryptedString;
}
/// This function converts a binary
/// number of type <String> to a decimal number
/// of type <String>. It multiplies each digit
/// by a power of 2.
String binToDec(String binaryNumber){
    List<String> origDigitsList = binaryNumber.split('');
    List<String> digitsList = List.from(origDigitsList.reversed);
    int lenDigitsList = digitsList.length;
    int decimalSum = 0;
    for(var i=0; i<lenDigitsList; i++){
      if(digitsList[i] == '1'){
        int toAdd = pow(2,i).toInt();
        decimalSum = decimalSum + toAdd;
      }
      else{
      }
    }
    String result = decimalSum.toString();
    return result;
  }
  /// This function converts a decimal
  /// number of type <int> to a binary number
  /// of type <String>. It keeps dividing
  /// by 2 until it hits 0.
  String decToBin(int decimalNumber){
    List<String> endChars = [];
    int dec = decimalNumber;
    int initItem = dec%2;
    String startDigit = initItem.toString();
    endChars.add(startDigit);
    while((dec~/2).toInt() != 0){
      dec = (dec~/2).toInt();
      int itemOneToAdd = dec%2;
      String itemTwoToAdd = itemOneToAdd.toString();
      endChars.add(itemTwoToAdd);
    }
    var reversedChars = List.from(endChars.reversed);
    String result = reversedChars.join('');
    return result;
  }
/// This function tests all of the available functions..
void testAll(){
  int factor = 5;
  String testLetter = 'A';
  String testWord = 'TEST';
  String testPhrase = 'HELLO WORLD';
  String binaryNumber = '1011';
  int encryptedLetter = encryptLetter(factor,testLetter);
  String encryptedWord = encryptWord(factor, testWord);
  String encryptedPhrase = encryptPhrase(factor, testPhrase);
  String decryptedLetter = decryptLetter(factor, encryptedLetter);
  String decryptedWord = decryptWord(factor, encryptedWord);
  String decryptedPhrase = decryptPhrase(factor, encryptedPhrase);
  String decToBinNum = decToBin(factor);
  String binToDecNum = binToDec(binaryNumber);
  print(encryptedLetter);
  print(encryptedWord);
  print(encryptedPhrase);
  print(decryptedLetter);
  print(decryptedWord);
  print(decryptedPhrase);
  print(decToBinNum);
  print(binToDecNum);

}
